Unit FPrinter;
{   ࠡ  ᪨ ਭ஬ IBM/Epson }

Interface

Var
  PLPT   : Array [1..3] of Word Absolute $0040:$0008;   {  LPT }
  CurLPT : Byte;                                        { 騩 LPT }
  LSpace : Byte;                                        { -  ' ' }
  LHeight: Byte;                                        {   1/216 }
  SendError : Boolean;                        {  訡 ।  }

Function LPTPresent (N : Byte) : Boolean;
{ 頥 TRUE, ᫨ ⠭ N- LPT }

Function PrnInit : Boolean;
{ 頥 TRUE, ᫨ 樠  LPT,  ਭ 祭 }

Function PrnStatus : Byte;
{ 頥 祭 - ਭ }

Procedure PrnSend (Data : Char);
{ 뫠  ਭ ᨬ Data }

Procedure PrnClearBuf;
{ 頥  /뢮 ਭ }

Procedure PrnHome;
{ ६頥  ਭ  砫 ப }

Procedure PrnLeft;
{ ६頥     ᨬ }

Procedure PrnRight;
{ ६頥  ࠢ   ᨬ }

Procedure PrnCharSet (CS : Byte);
{ 롨ࠥ  CS (1  2) ᨬ ਭ }

Procedure PrnBell;
{ ⠢ ਭ ᪭  }

Procedure PrnCR;
{ 뫠 ਭ ᨬ  ப }

Procedure PrnLF;
{ ப稢 㬠  ப  }

Procedure PrnFF;
{ ப稢 㬠  ᫥饩 ࠭ }

Procedure PrnIndex (I : Byte);
{ 롮 ० : I = 0 - 孨, 1 - , 2 - ⬥ ० }

Procedure PrnUnderLine (UL : Boolean);
{ 롮 ० ન, ᫨ UL = TRUE,  - ⬥ ० }

Procedure PrnDoubleWidth (DW : Boolean);
{ 롮 ०  ਭ, ᫨ DW = TRUE,  - ⬥ ० }

Procedure PrnCompressed (C : Boolean);
{ 롮 ० ⭮ , ᫨ C = TRUE,  - ⬥ ० }

Procedure PrnDoubleStrike (DS : Boolean);
{ 롮 ०  㤠, ᫨ DS = TRUE,  - ⬥ ० }

Procedure PrnBold (B : Boolean);
{ 롮 ० ୮ , ᫨ B = TRUE,  - ⬥ ० }

Procedure PrnString (S : String);
{ ⠥ ப S }

Procedure Prn72 (N : Byte);
{ ⠭  ࢠ N/72 }

Procedure Prn216 (N : Byte);
{ ⠭  ࢠ N/216 }

Procedure Prn480 (Len : Word);
{ ⠭ 480- ᪨ ०; Len - ꥬ  }

Procedure Prn960 (Len : Word);
{ ⠭ 960- ᪨ ०; Len - ꥬ  }

Implementation

Uses CRT, DOS;

Function LPTPresent (N : Byte) : Boolean;
Var I : Byte;
Begin
  If N = 0 then
    Begin
      For I := 1 to 3 do
        If PLPT[I] <> 0 then
          Begin
            LPTPresent := True;
            Exit
          End
    End
  Else
    If N <= 3 then LPTPresent := PLPT[N] <> 0
    Else LPTPresent := False
End;

Function PrnInit : Boolean;
Var T : Byte;
Begin
  Port[PLPT[CurLPT]+2] := $08; Delay (50);
  Port[PLPT[CurLPT]+2] := $0C;
  T := 0;
  While Port[PLPT[CurLPT]+1] and 128 = 0 do
    Begin
      Delay (500);
      Inc (T);
      If T = 20 then Break
    End;
  If T < 20 then Prn216 (LHeight);
  PrnInit := T < 20
End;

Function PrnStatus : Byte;
Begin PrnStatus := Port[PLPT[CurLPT]+1] End;

Procedure PrnSend (Data : Char);
Var
  Timer : LongInt absolute $40:$6C;
  T     : LongInt;
Begin
  SendError := False;
  T := Timer;
  Port[PLPT[CurLPT]] := Byte(Data);
  Port[PLPT[CurLPT]+2] := $0D;
  Port[PLPT[CurLPT]+2] := $0C;
  While Port[PLPT[CurLPT]+1] and $80 = 0 do
    If Timer > T+36 then
      Begin
        SendError := True;
        Exit
      End
End;

Procedure PrnClearBuf;
Begin PrnSend (#$18) End;

Procedure PrnHome;
Begin PrnSend (#27); If SendError then Exit; PrnSend ('<') End;

Procedure PrnLeft;
Begin PrnSend (#$08) End;

Procedure PrnRight;
Begin PrnSend (' ') End;

Procedure PrnCharSet (CS : Byte);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend (Chr($38-CS))
End;

Procedure PrnBell;
Begin PrnSend (#$07) End;

Procedure PrnCR;
Begin PrnSend (#$0D) End;

Procedure PrnLF;
Begin PrnSend (#$0A) End;

Procedure PrnFF;
Begin PrnSend (#$0C) End;

Procedure PrnIndex (I : Byte);
Begin
  Case I of
    0,
    1 : Begin
          PrnSend (#27); If SendError then Exit;
          PrnSend ('S'); If SendError then Exit;
          PrnSend (Char(I))
        End;
    2 : Begin
          PrnSend (#27); If SendError then Exit;
          PrnSend ('T')
        End
  End
End;

Procedure PrnUnderLine (UL : Boolean);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend ('-'); If SendError then Exit;
  PrnSend (Char(UL))
End;

Procedure PrnDoubleWidth (DW : Boolean);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend ('W'); If SendError then Exit;
  PrnSend (Char(DW))
End;

Procedure PrnCompressed (C : Boolean);
Begin PrnSend (Chr($12-3*Ord(C))) End;

Procedure PrnDoubleStrike (DS : Boolean);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend (Chr(Ord('H')-Ord(DS)))
End;

Procedure PrnBold (B : Boolean);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend (Chr(Ord('F')-Ord(B)))
End;

Procedure PrnString (S : String);
Var I : Byte;
Begin
  PrnHome;
  If LSpace > 0 then
    For I := 1 to LSpace do
      Begin
        PrnRight; If SendError then Exit;
      End;
  If S <> '' then
    For I := 1 to Length(S) do
      Begin
        PrnSend (S[I]); If SendError then Exit;
      End;
  PrnCR; If SendError then Exit;
  PrnLF
End;

Procedure Prn72 (N : Byte);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend ('A'); If SendError then Exit;
  PrnSend (Char(N))
End;

Procedure Prn216 (N : Byte);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend ('3'); If SendError then Exit;
  PrnSend (Char(N))
End;

Procedure Prn480 (Len : Word);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend ('K'); If SendError then Exit;
  PrnSend (Chr(Len mod 256)); If SendError then Exit;
  PrnSend (Chr(Len div 256))
End;

Procedure Prn960 (Len : Word);
Begin
  PrnSend (#27); If SendError then Exit;
  PrnSend ('L'); If SendError then Exit;
  PrnSend (Chr(Len mod 256)); If SendError then Exit;
  PrnSend (Chr(Len div 256))
End;

Begin
  CurLPT := 1;
  LHeight := 36;
  LSpace := 0;
  SendError := False
End.
